<?php
//
// +--------------------------------------------------------------------+
// | PHP version 4                                                      |
// +--------------------------------------------------------------------+
// | Copyright (c) 2005-2005 Nekomimisha                                |
// +--------------------------------------------------------------------+
// | This source file is subject to version 3.00 of the PHP License,    |
// | that is available at http://www.php.net/license/3_0.txt.           |
// | If you did not receive a copy of the PHP license and are unable to |
// | obtain it through the world-wide-web, please send a note to        |
// | license@php.net so we can mail you a copy immediately.             |
// +--------------------------------------------------------------------+
// | Authors: YAMAOKA Hiroyuki <yamaoka@catwalker.jp>                   |
// +--------------------------------------------------------------------+
//

/**
 * 顼ϥɥ饯饹Ǥ
 * 
 * @access public
 * @author YAMAOKA Hiroyuki
 * @package moony.util
 */
class Moony_ErrorHandler {

	/**
	 * 󥹥ȥ饯Ǥ
	 *
	 * @access public
	 */
	function Moony_ErrorHandler() {
	}

	/**
	 * 顼ϥɥȤƤΥ饹ꤷޤ
	 *
	 * @access public
	 */
	function register() {
		set_error_handler(array(&$this, 'handle'));
	}

	/**
	 * ȯ顼Υϥɥ󥰤Ԥޤ
	 * 顼ϡHTTPΥơ500֤λޤ
	 * 
	 * @access public
	 * @param int $code 顼
	 * @param string $message å
	 * @param string $file ƤӽФΥե̾
	 * @param int $line ƤӽФιֹ
	 */
	function handle($code, $message, $file, $line) {

		Moony_Logger::log($message, $file, $line);

		switch ($code) {
			case E_ERROR:
			case E_PARSE:
			case E_NOTICE:
			case E_USER_ERROR:
			case E_USER_WARNING:
			case E_USER_NOTICE:

				header('HTTP/1.0 500 Internal Server Error');
				exit;
		}
	}
}
?>