<?php
//
// +--------------------------------------------------------------------+
// | PHP version 4                                                      |
// +--------------------------------------------------------------------+
// | Copyright (c) 2005 The Moony Project                               |
// +--------------------------------------------------------------------+
// | This source file is subject to version 3.00 of the PHP License,    |
// | that is available at http://www.php.net/license/3_0.txt.           |
// | If you did not receive a copy of the PHP license and are unable to |
// | obtain it through the world-wide-web, please send a note to        |
// | license@php.net so we can mail you a copy immediately.             |
// +--------------------------------------------------------------------+
// | Authors: YAMAOKA Hiroyuki <yamaoka@catwalker.jp>                   |
// +--------------------------------------------------------------------+
//

/**
 * ꥯȾǼ륯饹Ǥ
 * 
 * @access public
 * @author YAMAOKA Hiroyuki
 * @package moony.core
 */
class Moony_Request {

	/** @var array ºݤΥѥ᡼Ǽ */
	var $_params;

	/**
	 * 󥹥ȥ饯Ǥ
	 * 
	 * @access public
	 */
	function Moony_Request() {
	}

	/**
	 * ѥ᡼ߤޤ
	 * 
	 * @access public
	 */
	function store() {
		$this->_params = ($_SERVER['REQUEST_METHOD'] == 'POST') ? $_POST : $_GET;
		$this->_sanitize($this->_params);
	}

	/**
	 * ѥ᡼ͤޤ
	 * 
	 * @access public
	 * @param string $name ѥ᡼
	 * @param mixed $alt ѥ᡼¸ߤʤ͡ʡʥǥե<code>null</code>ˡ
	 * @return mixed ѥ᡼
	 */
	function get($name, $alt = null) {

		if (!isset($this->_params[$name])) {
			return $alt;
		}

		return $this->_params[$name];
	}

	/**
	 * ˥󥰤Ԥޤ
	 * NULLХʸޤ
	 * 
	 * @access private
	 * @param mixed $data ˥оݤΥǡ
	 * @return string ˥Ѥʸ
	 */
	function _sanitize($data) {

		if (is_array($data)) {
			// Ƶ
			return array_map(array(&$this, '_sanitize'), $data);
		}

		return str_replace("\0", '', $data);
	}
}
?>