<?php
//
// +--------------------------------------------------------------------+
// | PHP version 4                                                      |
// +--------------------------------------------------------------------+
// | Copyright (c) 2005-2005 Nekomimisha                                |
// +--------------------------------------------------------------------+
// | This source file is subject to version 3.00 of the PHP License,    |
// | that is available at http://www.php.net/license/3_0.txt.           |
// | If you did not receive a copy of the PHP license and are unable to |
// | obtain it through the world-wide-web, please send a note to        |
// | license@php.net so we can mail you a copy immediately.             |
// +--------------------------------------------------------------------+
// | Authors: YAMAOKA Hiroyuki <yamaoka@catwalker.jp>                   |
// +--------------------------------------------------------------------+
//

define('MOONY_LOG_FORMAT_LINES', "%s %s - %s(L:%s)\n");
define('MOONY_LOG_FORMAT_CALLER', "%s %s - %s\n");
define('MOONY_LOG_FORMAT_NORMAL', "%s %s\n");

/**
 * ϥ饹Ǥ
 * 
 * @access public
 * @author YAMAOKA Hiroyuki
 * @package moony.util
 */
class Moony_Logger {

	/**
	 * ե˥Ϥޤ
	 * 
	 * @access public
	 * @static
	 * @param string $message å
	 * @param string $caller ƤӽФ˴ؤʻǤա
	 * @param int $line ƤӽФιԤ˴ؤʻǤա
	 */
	function log($message, $caller = null, $line = null) {

		$system_date = date('Y/m/d H:i:s');

		$log_file = MOONY_LOG_FILE;
		if (MOONY_LOG_ROTATE) {
			$log_file .= '.' . date('Ymd');
		}

		if (strlen($caller) > 0) {
			if (strlen($line) > 0) {
				$message = sprintf(MOONY_LOG_FORMAT_LINES, $system_date, $message, $caller, $line);
			} else {
				$message = sprintf(MOONY_LOG_FORMAT_CALLER, $system_date, $message, $caller);
			}
		} else {
			$message = sprintf(MOONY_LOG_FORMAT_NORMAL, $system_date, $message);
		}

		@error_log($message, 3, $log_file);
	}
}
?>